;The TTP Project Boot Loader 0.3.2
;Copyright 2000-2001 Leif Ames and Michael Benoit
;Based on the RavenOS Boot Sector 0.1.0

org 0                            ;We don't want NASM to mess with our addresses
jmp Start                          ;Keep the GDT and other data from being executed

%include "text.asm"
%include "messages.inc"
%include "gdt.inc"
%include "8259.asm"
%include "n2o.asm"
%include "loadk.asm"


[bits 16]
Start:                         
	mov ax, 0x7c0          ;Load 0x7c0 in to DS
	mov ds, ax             ;Not sure why, but the 486 needs this...
	
	call loadfile
	call pic
	call A20
	
	cli                    ;Mask interupts
	mov al, 0x80           ;Stop NMIs as well
	out 0x70, al
        print GDTL
	lgdt [gdt+2]           ;Load the gdt!
        print GOPMODE
gopm:
	mov eax, cr0           ;Copy Control Register 0 into EAX
      or al,1                ;Increment EAX (PMODE enable bit now 1)
      mov cr0, eax           ;Copy EAX into Control Register 0
	jmp short $+2          ;JMP to next line (Clear prefetch queue)
	jmp 0x08:pmode+7c00h   ;JMP to the 32 bit code!

	
[bits 32]
pmode:                         ;Should be in PMODE now...
	mov ax, 0x10           ;Select data descriptor   
	mov ds, ax                
	mov [0xB8000], word 0x0154 ;stuff
	mov [0xB8002], word 0x0154
	mov [0xB8004], word 0x0150
	jmp DWORD  0x08:0x10000  
	  jmp short $                ;Sit and do nothing (infinite Loop)

	times 510-($-$$) db 0  ;Move to offset 510 in the BS
	dw 0xAA55              ;Boot Sector identifier
